Arena = LibStub("AceAddon-3.0"):NewAddon("Arena", "AceEvent-3.0")
local scheduleframe = CreateFrame("Frame")
local lsm3 = LibStub("LibSharedMedia-3.0")
local auracache, drs = {}, {}
local CCs = {
	["PALADIN"]={
		[853]="STUN",
		[20066]="INCAPACIPATE",
		[53709]="SILENCE",
	},
	["DRUID"]={
		[33786]="CYCLONE",
		[22570]="STUN",
		[9005]="OPENER_STUN",
		--[16979]="CHARGE",
		[5211]="STUN",
		[339]="ROOT",
	},
	["DEATHKNIGHT"]={
		[47476]="SILENCE",
		[49203]="DISORIENT",
		[47481]="STUN",
	},
	["HUNTER"]={
		[1499]="DISORIENT",
		[19503]="SCATTERSHOT",
		[19577]="STUN",
		[19386]="DISORIENT",
	},
	["WARRIOR"]={
		[100]="CHARGE",
		[5246]="FEAR",
		[12809]="STUN",
		[46968]="STUN",
	},
	["MAGE"]={
		[28271]="DISORIENT",
		[12598]="SILENCE",
	},
	["PRIEST"]={
		[8122]="FEAR",
		[15487]="SILENCE",
	},
	["WARLOCK"]={
		[5782]="FEAR",
		[6358]="CHARM",
		[30283]="STUN",
		[19647]="SILENCE",
	},
	["SHAMAN"]={
		[51514]="DISORIENT",
	},
	["ROGUE"]={
		[26884]="SILENCE",
		[1833]="OPENER_STUN",
		[8643]="STUN",
		[51724]="DISORIENT",
		[2094]="BLIND",
	},
	["Tauren"]={
		[20549]="STUN",
	},
	["BloodElf"]={
		[28730]="SILENCE",
	},
}
local dr_categories = {
	[853]="STUN",
	[20066]="INCAPACIPATE",
	[53709]="SILENCE",
	[33786]="CYCLONE",
	[22570]="STUN",
	[9005]="OPENER_STUN",
	--[16979]="CHARGE",
	[5211]="STUN",
	[339]="ROOT",
	[47476]="SILENCE",
	[49203]="DISORIENT",
	[47481]="STUN",
	[1499]="DISORIENT",
	[19503]="SCATTERSHOT",
	[19577]="STUN",
	[19386]="DISORIENT",
	[100]="CHARGE",
	[5246]="FEAR",
	[12809]="STUN",
	[46968]="STUN",
	[28271]="DISORIENT",
	[12598]="SILENCE",
	[8122]="FEAR",
	[15487]="SILENCE",
	[5782]="FEAR",
	[6358]="CHARM",
	[30283]="STUN",
	[19647]="SILENCE",
	[51514]="DISORIENT",
	[26884]="SILENCE",
	[1833]="OPENER_STUN",
	[8643]="STUN",
	[51724]="DISORIENT",
	[2094]="BLIND",
	[20549]="STUN",
	[28730]="SILENCE",
}
local talent_spells = {
	[12598]={1,12},
	[53709]={2,24},
}
local shared_drs={
	["FEAR"]={"CHARM","BLIND"},
	["CHARM"]={"FEAR","BLIND"},
	["BLIND"]={"FEAR","CHARM"},
}
local debuff_ids={
	[853]=853,
	[20066]=20066,
	[63529]=53709,
	[33786]=33786,
	[22570]=22570,
	[9005]=9005,
	--[45334]=16979,
	[5211]=5211,
	[339]=339,
	[47476]=47476,
	[49203]=49203,
	[47481]=47481,
	[14309]=1499,
	[1499]=1499,
	[19503]=19503,
	[19577]=19577,
	[19386]=19386,
	[7922]=100,
	[5246]=5246,
	[12809]=12809,
	[46968]=46968,
	[28271]=28271,
	[55021]=12598,
	[8122]=8122,
	[15487]=15487,
	[5782]=5782,
	[6358]=6358,
	[30283]=30283,
	[19647]=19647,
	[51514]=51514,
	[1330]=26884,
	[1833]=1833,
	[8643]=8643,
	[51724]=51724,
	[2094]=2094,
	[20549]=20549,
	[28730]=28730,
}

scheduleframe.s = {}
scheduleframe:SetScript("OnUpdate", function(self)
	if #self.s < 1 then self:Hide() return end
	while self.s[1] and self.s[1].t <= GetTime() do
		if type(self.s[1].f) == "string" then
			Arena[self.s[1].f](Arena, unpack(self.s[1].a))
		else
			self.s[1].f(unpack(self.s[1].a))
		end
		tremove(self.s,1)
	end
end)
local function round(num, places)
	return tonumber(string.format("%."..(places or 0).."f",num))
end
local options = {
	type="group",
	args={}
}
local defaults={profile={
	looks = {
		font = lsm3:GetDefault("font"),
		bar = lsm3:GetDefault("statusbar"),
		gryphon = true,
	},
	positioning = {
		enemy={},
		friendly={},
	},
	attributes={
		enemy={
			type2="focus",
		},
		friendly={
			type2="assist",
		}
	}
}}
function Arena:ScheduleTimer(t, f, ...)
	t = t+GetTime()
	tinsert(scheduleframe.s, {t=t,f=f,a={...}})
	table.sort(scheduleframe.s, function(a,b) return a.t < b.t end)
	if not scheduleframe:IsShown() then scheduleframe:Show() end
end
function Arena:OnProfileEnable()
	self.opt = self.db.profile
end
local hframes = {}
function Arena:ScheduleHide(f)
	tinsert(hframes, f)
	f:SetScript("OnUpdate", nil)
end

local frameupdate = function(self)
	local u = self.unit
	local h,p,mh,mp,cr,cg,cb,pbct,uh,up,upt,ue,uc, uht
	ue = UnitExists(u)
	if ue then
		h,p,mh,mp,cr,cg,cb = UnitHealth(u), UnitPower(u), UnitHealthMax(u), UnitPowerMax(u)
		_, uc = UnitClass(u)
		pbct = PowerBarColor[(select(2,UnitPowerType(u)))]
		cr,cg,cb = pbct.r,pbct.g,pbct.b
		if self.c.h ~= h then
			self.c.h = h
			uh = true
		end
		if self.c.mh ~= mh then
			self.c.mh = mh
			uh = true
		end
		if self.c.p ~= p then
			self.c.p = p
			up = true
		end
		if self.c.mp ~= mp then
			self.c.mp = mp
			up = true
		end
		if self.c.cr ~= cr then
			self.c.cr = cr
			upt = true
		end
		if self.c.cg ~= cg then
			self.c.cg = cg
			upt = true
		end
		if self.c.cb ~= cb then
			self.c.cb = cb
			upt = true
		end
		if self.c.uc ~= uc then
			self.c.uc = uc
			uht = true
		end
		if uh then
			local hf = self.health
			hf.t:SetText(h.."/"..mh.." ("..(mh == 0 and 0 or round(h/mh*100,0)).."%)")
			hf.tx:SetWidth(h == 0 and -1 or hf:GetWidth()*h/mh)
		end
		if up then
			local pf = self.power
			pf.t:SetText(p.."/"..mp.." ("..(mp == 0 and 0 or round(p/mp*100,0)).."%)")
			pf.tx:SetWidth(p == 0 and -1 or pf:GetWidth()*p/mp)
		end
		if uht then
			local a = RAID_CLASS_COLORS[uc]
			self.health.tx:SetVertexColor(a.r,a.g,a.b)
		end
		if upt then
			self.power.tx:SetVertexColor(cr,cg,cb)
		end
	else
		self.c.h, self.c.mh, self.c.p, self.c.mp = -2,-2,-2,-2
		self.health.t:SetText("?/?")
		self.health.tx:SetWidth(-1)
		self.power.t:SetText("?/?")
		self.power.tx:SetWidth(-1)
	end
end
function Arena:PLAYER_REGEN_ENABLED()
	for i,k in ipairs(hframes) do
		k:Hide()
		k:SetScript("OnUpdate", frameupdate)
	end
	table.wipe(hframes)
end

local function framedown(self,button)
	if button == "RightButton" and (IsLeftShiftKeyDown() or IsRightShiftKeyDown()) and not InCombatLockdown() then
		self.moving = true
		self:StartMoving()
	end
end

function Arena:InitFrame(frame)
	local unit, key = frame.unit, frame.key
	if key:find("1") then
		frame:SetMovable(true)
		frame:SetScript("OnMouseDown", framedown)
	end
	frame.health = CreateFrame("Frame", nil, frame)
	frame.power = CreateFrame("Frame", nil, frame)
	--frame.health:SetPoint("TOPRIGHT", )
	frame.health.tx = frame.health:CreateTexture(nil, "BACKGROUND")
	frame.health.tx:SetPoint("TOPLEFT")
	frame.health.tx:SetPoint("BOTTOMLEFT")
	frame.health.tx:SetTexture(lsm3:Fetch("statusbar", self.opt.looks.bar))
	frame.health.t = frame.health:CreateFontString(nil, "ARTWORK")
	frame.health.t:SetAllPoints()
	frame.health.t:SetFont(lsm3:Fetch("font", self.opt.looks.font), 16, "OUTLINE")
	frame.health.t:SetTextColor(1,1,1)
	frame.power:SetPoint("TOPLEFT", frame.health, "BOTTOMLEFT")
	frame.power:SetPoint("TOPRIGHT", frame.health, "BOTTOMRIGHT")
	frame.power.tx = frame.power:CreateTexture(nil, "BACKGROUND")
	frame.power.tx:SetPoint("TOPLEFT")
	frame.power.tx:SetPoint("BOTTOMLEFT")
	frame.power.tx:SetTexture(lsm3:Fetch("statusbar", self.opt.looks.bar))
	frame.power.t = frame.power:CreateFontString(nil, "ARTWORK")
	frame.power.t:SetAllPoints()
	frame.power.t:SetFont(lsm3:Fetch("font", self.opt.looks.font), 16, "OUTLINE")
	frame.power.t:SetTextColor(1,1,1)
	frame.c = {}
	frame:SetScript("OnUpdate", frameupdate)
	frame.texture = frame:CreateTexture(nil, "BORDER")
	frame.texture:SetAllPoints()
	frame.tframe = CreateFrame("Frame", nil, frame)
	frame.tframe:SetFrameLevel(3)
	frame.texture2 = frame.tframe:CreateTexture(nil, "ARTWORK")
	frame.texture2:SetAllPoints(frame)
	if not self.opt.looks.gryphon then
		frame.texture2:Hide()
	end
	frame:Hide()
end

function Arena:UpdateFrameShowHide()
	if InCombatLockdown() then return end
	local isArena = IsActiveBattlefieldArena()
	local teamsize
	if isArena then
		for bg=1, MAX_BATTLEFIELD_QUEUES do
			local status, mapname, instanceid, bracketmin, bracketmax, size = GetBattlefieldStatus(bg)
			if status == "active" and size ~= 0 then
				teamsize = size
				break
			end
		end
	else
		teamsize = 0
	end
	for nf=1, teamsize do
		self.frames["arena"..nf]:Show()
		self.frames["team"..nf]:Show()
		auracache["arena"..nf] = {}
		drs["arena"..nf] = {}
		self:UpdateDisplays("arena"..nf)
	end
	for nhf=teamsize+1, 5 do
		self.frames["arena"..nhf]:Hide()
		self.frames["team"..nhf]:Hide()
	end
end

--[[function Arena:PLAYER_ENTERING_WORLD()
	Arena:ScheduleTimer(0.5, "UpdateFrameShowHide")
	self:UpdateFrameShowHide()
end--]]

function Arena:ScanSpellIDs()
	local a={}
	for n,i in pairs(debuff_ids) do
		if type(n) == "number" then
			a[(GetSpellInfo(n))] = i
		end
	end
	debuff_ids = a
	self:UnregisterEvent("SPELLS_CHANGED")
end
Arena:RegisterEvent("SPELLS_CHANGED","ScanSpellIDs")

function Arena:UpdateNameDisplay(event, unit)
	local u = string.match(unit, "party(%d)")
	if unit == "player" then u = 0 end
	if not u then return end
	u = tonumber(u) + 1
	f = self.frames["team"..u]
	f.name:SetText((UnitName(unit)))
end
Arena:RegisterEvent("UNIT_NAME_UPDATE", "UpdateNameDisplay")

function Arena:UpdateDisplays(unit)
	local aura, dr = auracache[unit], drs[unit]
	local applicable_debuffs = {}
	for num in pairs(CCs[(select(2, UnitClass("player")))]) do
		if talent_spells[num] then
			local _,_,_,_,rank = GetTalentInfo(unpack(talent_spells[num]))
			if rank > 0 then
				tinsert(applicable_debuffs, {t="talent", id=num, tab=talent_spells[num][1], talent=talent_spells[num][2]})
			end
		elseif (GetSpellInfo((GetSpellInfo(num)))) then
			tinsert(applicable_debuffs, {t="spell",id=num})
		end
	end
	if CCs[(select(2, UnitRace("player")))] then
		for num in pairs(CCs[(select(2, UnitRace("player")))]) do
			tinsert(applicable_debuffs, {t="spell",id=num})
		end
	end
	for i,k in ipairs(applicable_debuffs) do
		local n,r,ic
		if k.t=="spell" then
			n,r,ic= GetSpellInfo(k.id)
		elseif k.t == "talent" then
			n,ic = GetTalentInfo(k.tab,k.talent)
		end
		local f = self.frames[unit]
		f["spell"..i]:Show()
		f["spell"..i]:SetTexture(ic)
		f["btn"..i.."in"]:Show()
		local d = dr[dr_categories[k.id]] or 0
		f["btn"..i.."in"]:SetTexture("Interface\\AddOns\\Arena\\button_in"..(d==2 and "_quarter.tga" or d==1 and "_half.tga" or ".tga"))
		f["btn"..i]:Show()
	end
	for c=(#applicable_debuffs+1), 5 do
		local f = self.frames[unit]
		f["btn"..c]:Hide()
		f["btn"..c.."in"]:Hide()
		f["spell"..c]:Hide()
	end
end

function Arena:RemoveDR(unit, category, status)
	if drs[unit][category] ~= status then return end
	drs[unit][category] = 0
	Arena:UpdateDisplays(unit)
end

function Arena:UpdateAuras(event,unit)
	if not unit:find("arena%d") then return end
	local shouldupdate = false
	if not auracache[unit] then print(unit) end
	for buff, ison in pairs(auracache[unit]) do
		if not UnitDebuff(unit, buff) then
			auracache[unit][buff] = nil
			shouldupdate = true
		end
	end
	local i = 1
	local name = UnitDebuff(unit, i)
	while name do
		if debuff_ids[name] then
			if not auracache[unit][name] then
				auracache[unit][name] = true
				drs[unit][dr_categories[debuff_ids[name]]] = (drs[unit][dr_categories[debuff_ids[name]]] or 0) + 1
				self:ScheduleTimer(15, "RemoveDR", unit, dr_categories[debuff_ids[name]], drs[unit][dr_categories[debuff_ids[name]]])
				if shared_drs[dr_categories[debuff_ids[name]]] then
					for k,cat in ipairs(shared_drs[dr_categories[debuff_ids[name]]]) do
						drs[unit][cat] = (drs[unit][cat] or 0)+1
						self:ScheduleTimer(15, "RemoveDR", unit, cat, drs[unit][cat])
					end
				end
				shouldupdate = true
			end
		end
		i=i+1
		name = UnitDebuff(unit, i)
	end
	if shouldupdate then
		Arena:UpdateDisplays(unit)
	end
end

function Arena:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ArenaConfig", defaults)
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("LibDualSpec-1.0"):EnhanceDatabase(self.db, "Arena")
	LibStub("LibDualSpec-1.0"):EnhanceOptions(options.args.profiles, self.db)
	options.args.profiles.order = -1
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileEnable")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileEnable")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileEnable")
	self.opt = self.db.profile
	Arena:RegisterEvent("UPDATE_BATTLEFIELD_STATUS","UpdateFrameShowHide")
	Arena:RegisterEvent("PLAYER_REGEN_ENABLED")
	Arena:RegisterEvent("UNIT_AURA", "UpdateAuras")
	self.frames = {}
	for i=1, 5 do
		local f = CreateFrame("Button", "ArenaEnemy"..i.."Button", UIParent, "SecureUnitButtonTemplate")
		SecureUnitButton_OnLoad(f,"arena"..i, function() end)
		for attribute,value in pairs(self.opt.attributes.enemy) do
			f:SetAttribute(attribute, value)
		end
		self.frames["arena"..i] = f
		if i > 1 then
			f:SetPoint("TOP", self.frames["arena"..(i-1)], "BOTTOM", 0, -10)
		else
			f:SetPoint(self.opt.positioning.enemy.point or "CENTER", nil, self.opt.positioning.enemy.rpoint or "CENTER", self.opt.positioning.enemy.x or 0, self.opt.positioning.enemy.y or 100)
		end
		f:SetScript("OnMouseUp", function(self)
			if not self.moving then return end
			self.moving = false
			self:StopMovingOrSizing()
			Arena.opt.positioning.enemy.point, _, Arena.opt.positioning.enemy.rpoint, Arena.opt.positioning.enemy.x, Arena.opt.positioning.enemy.y = self:GetPoint()
		end)
		f:SetHeight(100)
		f:SetWidth(300)
		f:SetScale(self.opt.positioning.enemy.scale or 1)
		f.unit = f:GetAttribute("unit")
		f.key = "arena"..i
		self:InitFrame(f)
		f.health.tx:SetVertexColor(1,0,0)
		f.texture:SetTexture("Interface\\AddOns\\Arena\\BG_enemy.tga")
		f.texture2:SetTexture("Interface\\AddOns\\Arena\\BG_enemy2.tga")
		f.power:SetPoint("BOTTOMLEFT", 90, 10)
		f.health:SetPoint("BOTTOM", f, "CENTER", 45, -20)
		f.health:SetPoint("TOPLEFT", 90, -30)
		for tx=5, 1, -1 do
			local btn = f:CreateTexture(nil, "OVERLAY")
			local btn_in = f:CreateTexture(nil, "ARTWORK")
			btn:SetWidth(14)
			btn:SetHeight(14)
			btn:SetTexture("Interface\\AddOns\\Arena\\button.tga")
			btn_in:SetAllPoints(btn)
			btn_in:SetTexture("Interface\\AddOns\\Arena\\button_in.tga")
			f["btn"..tx] = btn
			f["btn"..tx.."in"] = btn_in
			local spell = f:CreateTexture(nil, "OVERLAY")
			spell:SetWidth(18)
			spell:SetHeight(18)
			--spell:SetTexture("Interface\\Icons\\Spell_Magic_PolymorphPig")
			f["spell"..tx] = spell
			if tx == 5 then
				btn:SetPoint("TOPRIGHT", -7, -6)
			else
				btn:SetPoint("RIGHT", f["btn"..(tx+1)], "LEFT", -24, 0)
			end
			spell:SetPoint("RIGHT", btn, "LEFT", -3, 0)
		end
	end
	for i=1, 5 do
		local f = CreateFrame("Button", "ArenaMember"..i.."Button", UIParent, "SecureUnitButtonTemplate")
		SecureUnitButton_OnLoad(f, i > 1 and "party"..(i-1) or "player", function() end)
		for attribute, value in pairs(self.opt.attributes.friendly) do
			f:SetAttribute(attribute, value)
		end
		self.frames["team"..i] = f
		if i > 1 then
			f:SetPoint("TOP", self.frames["team"..(i-1)], "BOTTOM", 0, -10)
		else
			f:SetPoint(self.opt.positioning.friendly.point or "CENTER", nil, self.opt.positioning.friendly.rpoint or "CENTER", self.opt.positioning.friendly.x or 100, self.opt.positioning.friendly.y or -100)
		end
		f:SetScript("OnMouseUp", function(self)
			if not self.moving then return end
			self.moving = false
			self:StopMovingOrSizing()
			Arena.opt.positioning.friendly.point, _, Arena.opt.positioning.friendly.rpoint, Arena.opt.positioning.friendly.x, Arena.opt.positioning.friendly.y = self:GetPoint()
		end)
		f:SetHeight(100)
		f:SetWidth(300)
		f:SetScale(self.opt.positioning.friendly.scale or 1)
		f.unit = f:GetAttribute("unit")
		f.key = "team"..i
		self:InitFrame(f)
		f.health.tx:SetVertexColor(0,1,0)
		f.texture:SetTexture("Interface\\AddOns\\Arena\\BG_friendly.tga")
		f.texture2:SetTexture("Interface\\AddOns\\Arena\\BG_friendly2.tga")
		f.power:SetPoint("BOTTOMLEFT", 2, 10)
		f.health:SetPoint("BOTTOM", f, "CENTER", -45, -15)
		f.health:SetPoint("TOPLEFT", 2, -30)
		f.name = f:CreateFontString(nil, "OVERLAY")
		f.name:SetTextColor(1,1,1)
		f.name:SetFont(lsm3:Fetch("font", self.opt.looks.font), 14, "OUTLINE")
		f.name:SetPoint("TOPLEFT", 7, -4)
		f.name:SetHeight(20)
		f.name:SetWidth(200)
		if i== 1 then
			f.name:SetText((UnitName("player")))
		end
	end
end